﻿using System;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace DrawGraph
{
    public class Settings
    {
        public static int VertexWidth = 10;
        public static int VertexHeight = 10;
        public static int StrokeThickness = 2;
        public static int FontSize = 16;
        public static Color FillColor = Color.FromRgb(0, 0, 0);

        public static void ClearCanvas(Edge[] edges, Vertex[] vertices)
        {
            if (edges != null && vertices != null)
            {
                Array.Clear(edges, 0, edges.Length);
                Array.Clear(vertices, 0, vertices.Length);
            }
            else
            {
                throw new NullReferenceException();
            }
        }

        public static void RemoveAllEdges(Canvas canvas, Line[] lines, Edge[] edges)
        {
            Array.Clear(edges, 0, edges.Length);
            for (int i = 0; i < lines.Length; i++)
            {
                canvas.Children.Remove(lines[i]);
            }
        }

        public static void RemoveLastAdded(Canvas canvas)
        {
            int removingElement = canvas.Children.Count-1;
            canvas.Children.RemoveAt(removingElement);
        }
    }
}
